package dev.pfaff.altargui.element;

import dev.pfaff.altargui.StateContext;
import dev.pfaff.altargui.internal.util.StencilLayoutContext;
import dev.pfaff.altargui.Widget;
import dev.pfaff.altargui.WidgetInstantiationArgs;
import org.jetbrains.annotations.MustBeInvokedByOverriders;

public abstract class SingleChildWidgetInstance<W extends Widget> extends CustomLayoutSingleChildWidgetInstance<W> {
	protected SingleChildWidgetInstance(WidgetInstantiationArgs args) {
		super(args);
	}

	@Override
	@MustBeInvokedByOverriders
	protected void computeStencilLayout(StateContext context) {
		StencilLayoutContext.updateMountAndLayout(context, this, getChildElement(), (e, ctx) -> {
			e.copyAvailableSizeFrom(this);
			e.stencilLayout(ctx);
			copyComputedSizeFrom(e);
		});
	}

	@Override
	@MustBeInvokedByOverriders
	protected void computeTraceLayout() {
		var e = getChildElement();
		e.copyPositionFrom(this);
		e.traceLayout();
	}
}
